# JITSU
Banyan Just-In-Time SSH user provisioning and auditing script


### Supported Operating Systems

Currently only tested on Ubuntu 18.04. We're working on testing on other Linux distros.


### 1. Download

Download the latest release of JITSU from our [releases page](https://github.com/banyansecurity/jitsu/releases) to the `/opt/banyan-packages` folder.

Ensure you have assumed root privileges:

```bash
user@host$ sudo su -
root@host#
```

Download and extract the Tarball installer, and cd into the directory:

```bash
# create folder for the Tarball
mkdir -p /opt/banyan-packages
cd /opt/banyan-packages

# clone the repo
git clone --branch 0.1.0 https://github.com/banyansecurity/jitsu jitsu-0.1.0
cd jitsu-0.1.0
```

**TODO: make this a tar.gz download**


### 2. Configure

You can set environment variables to disable specific JITSU capabilities.

```bash
# disable JIT Groups Creation
export NO_GROUPS=true
# disable JIT User Creation (includes NO_GROUPS) 
export NO_USERS=true 
```

**TODO: move to a config file**


### 3. Install

```bash
# run the setup script
./setup-jitsu.sh

# manage using systemctl
systemctl status jitsu
```

#### 4. Setup SSHD to trust Banyan certs

JITSU expects to find the Banyan SSH CA in `/etc/ssh/banyan_ca.pub`. You can find this Certificate by navigating to **Settings -> Advanced Settings** in the **Banyan Command Center**. 

```bash 
# paste in the Banyan SSH CA
vi /etc/ssh/banyan_ca.pub
```

**TODO: automatically add SSH CA, once given Banyan RefreshToken**


#### 5. Create Root and Default Roles Files that SSHD AuthorizedPrincipals will check 

When users attempt to log in as the user named `root`, JITSU will check if they have the proper roles available in their SSH Certificate against the **root roles file** located in `/opt/banyan/root.roles`. 

```bash 
# create the root.roles file
# This is a newline-separated file which lists the Banyan roles required to SSH in as a user named `root`

vi /opt/banyan/root.roles
```

**TODO: automatically create `root.roles`, once given Banyan RefreshToken and PolicyForRoot**


When users attempt to log in as any user not named `root`, JITSU will check if they have the proper roles available in their SSH Certificate against the **default roles file** located in `/opt/banyan/default.roles`. 

```bash 
# create the default.roles file
# This is a newline-separated file which lists the Banyan roles required to SSH in as a user not named `root`

vi /opt/banyan/default.roles
```

**TODO: automatically create `default.roles`, once given Banyan RefreshToken and PolicyForNonRoot**
